# GITLAB-CI job definition file for this repository
# VERSION: 2017-11-15-001


# COMMON RUNTIME VARS
# ===================
variables:
  # set build options
  BUILD_IMAGE_BASE: "${CI_REGISTRY_IMAGE}"
  BUILD_CLONE_PATH: "${CI_PROJECT_DIR}"
  # enable use of submodules
  GIT_SUBMODULE_STRATEGY: recursive
  # fix missing term env
  TERM: "xterm"




# COMMON PREPARATION TASKS
# ========================
before_script:
  # show environment info
  - echo "=> Running as USER $(whoami) on SERVER $(hostname -f)"
  - echo "=> Working dir is $(pwd)"
  - echo "=> Building ansible in version [$ANSIBLE_VERSION] (empty=latest)"
  # debug secret vars
  - echo "ANSIBLE_VERSION=$ANSIBLE_VERSION"
  - echo "FTP_UPLOAD_URL=$FTP_UPLOAD_URL"
  - echo "SKIP_EXTERNAL_TOOLS=$SKIP_EXTERNAL_TOOLS"
  # show content of build path
  - ls -la ${BUILD_CLONE_PATH}




# JOB STAGES
# ==========
stages:
  - BUILD_DOCKER_IMAGES
  - BUILD_ANSIBLE_TGZ




# JOB TEMPLATES
# =============

# for building docker images
.template_building_docker_images: &settings_for_building_docker_images
  stage: BUILD_DOCKER_IMAGES
  image: docker:latest
  services:
    - docker:dind
  only:
    - master
  tags:
    - docker


# for building virtualenv tgz releases
.template_ansible_venv: &settings_ansible_venv
  stage: BUILD_ANSIBLE_TGZ
  script:
    - ./build.ansible.sh $ANSIBLE_VERSION
  tags:
    - docker




# JOB ENTRIES
# =============

docker_image_apk:
  <<: *settings_for_building_docker_images
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE/apk -f apk.Dockerfile .
    - docker push $CI_REGISTRY_IMAGE/apk
    - docker login -u ${DOCKER_HUB_USER} -p ${DOCKER_HUB_PASS}
    - docker tag ${CI_REGISTRY_IMAGE}/apk ${DOCKER_HUB_IMAGE}:latest
    - docker push ${DOCKER_HUB_IMAGE}:latest


docker_image_lts:
  <<: *settings_for_building_docker_images
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE/lts -f lts.Dockerfile .
    - docker push $CI_REGISTRY_IMAGE/lts


tgz_virtualenv_lts:
  <<: *settings_ansible_venv
  image: ubuntu


tgz_virtualenv_el7:
  <<: *settings_ansible_venv
  image: centos:centos7


# eof
